*-----------------------------------------------------------------------------*
$Ontext
Nom

Description
Leon  Introduire le risque
Calcul revenu aleatoire

$Offtext
*-----------------------------------------------------------------------------*


SET
C culture                /ble, mais/
E etat de la nature      /E1*E5/
;

SCALAR
SAU    surface agricole utile disponible         /50/
Z0     revenu minimum                            /18000/
DMO    disponibilite de travail en heures        /2000/
;

PARAMETER
BMO(C) besoins en travail par hectare et par culture (heures)
/ble    25
 mais   50/
;

TABLE
MB(E,C) marge brute en fonction de l'tat de la nature et de la culture
          ble        mais
E1        460        2000
E2        440        500
E3        450        300
E4        430        1400
E5        470        800
;

PARAMETER
PROB(E) probabilit d'occurance de l'tat de la nature E
/E1 0.2
 E2 0.2
 E3 0.2
 E4 0.2
 E5 0.2
/
;

PARAMETER
MB(C);
MB(C)=sum(E, MB(E,C)*PROB(E));
display MB(C);

Variables
X(C)
Z
RAL(E)   revenu alatoire en fonction de l'tat de la nature
;
Positive variables X;

Equations
FO               fonction objectif
terre            contrainte de surface
travail          contrainte de travail
revenualea(E)    calcul des revenus alatoires
safetyFirst(E)   contrainte de minimum de revenu
;

*FO..               sum(E, RAL(E)*PROB(E))=e=Z;
FO..              sum(C, MB(C)*X(C)) =e= Z ;

terre..            sum(C,X(C))=l= SAU;

travail..          sum(C, X(C)*BMO(C)) =l= DMO ;

revenualea(E)..    sum(C, MB(E,C)*X(C))=e=RAL(E);

safetyFirst(E)..   RAL(E) =g= Z0 ;

Model modeleco /all/;

solve modeleco using LP maximizing Z ;
